using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using SubSystems.TE;
using SubSystems.HT;
using Keyoti.RapidSpell;

namespace RapidTernTest
{
    public class AYTTern : Tern, ISpellCheckableTextComponent, IAYTTextBox
    {

        ContextMenuStrip _cmsPopupMenu;
        CustomTextBoxUtilityAdapter tbu;
        public ContextMenuStrip cmsPopupMenu
        {
            get
            {
                return _cmsPopupMenu;
            }
            set
            {
                _cmsPopupMenu = value;
            }
        }
        public Htn HtmlObject
        {
            get
            {
                return _HtmlObject;
            }
            set
            {
                _HtmlObject = value;
            }
        }

        ToolStripMenuItem _tsmiCopy;
        ToolStripMenuItem _tsmiPaste;
        ToolStripMenuItem _tsmiCut;
        ToolStripMenuItem _tsmiSelectAll;
        ToolStripMenuItem _tsmiUndo;
        ToolStripMenuItem _tsmiDelete;
        ToolStripSeparator _tssFirstSeparator;
        ToolStripSeparator _tssSecondSeparator;
        bool _blHtmlEdit = false;
        Htn _HtmlObject;
        public void setHtmlObject()
        {
            _HtmlObject = new Htn(this);
        }
        public AYTTern()
        {
            _HtmlObject = new Htn(this);

            _cmsPopupMenu = new ContextMenuStrip();
            _cmsPopupMenu.Opening += new System.ComponentModel.CancelEventHandler(_cmsPopupMenu_Opening);

            _tsmiUndo = new ToolStripMenuItem();
            _tsmiUndo.Text = "Undo";
            _tsmiUndo.Click += new EventHandler(_tsmiUndo_Click);
            _cmsPopupMenu.Items.Add(_tsmiUndo);

            _tssFirstSeparator = new ToolStripSeparator();
            _cmsPopupMenu.Items.Add(_tssFirstSeparator);

            _tsmiCut = new ToolStripMenuItem();
            _tsmiCut.Text = "Cut";
            _tsmiCut.Click += new EventHandler(_tsmiCut_Click);
            _cmsPopupMenu.Items.Add(_tsmiCut);

            _tsmiCopy = new ToolStripMenuItem();
            _tsmiCopy.Text = "Copy";
            _tsmiCopy.Click += new EventHandler(_tsmiCopy_Click);
            _cmsPopupMenu.Items.Add(_tsmiCopy);

            _tsmiPaste = new ToolStripMenuItem();
            _tsmiPaste.Text = "Paste";
            _tsmiPaste.Click += new EventHandler(_tsmiPaste_Click);
            _cmsPopupMenu.Items.Add(_tsmiPaste);

            _tsmiDelete = new ToolStripMenuItem();
            _tsmiDelete.Text = "Delete";
            _tsmiDelete.Click += new EventHandler(_tsmiDelete_Click);
            _cmsPopupMenu.Items.Add(_tsmiDelete);

            _tssSecondSeparator = new ToolStripSeparator();
            _cmsPopupMenu.Items.Add(_tssSecondSeparator);

            _tsmiSelectAll = new ToolStripMenuItem();
            _tsmiSelectAll.Text = "Select All";
            _tsmiSelectAll.Click += new EventHandler(_tsmiSelectAll_Click);
            _cmsPopupMenu.Items.Add(_tsmiSelectAll);
            ContextMenuStrip = _cmsPopupMenu;
            this.VertScrollBar = true;
            this.HorzScrollBar = true;
            this.BorderMargin = false;

            TerCommand(tc.ID_FITTED_VIEW);
            TerSetFlags4(true, tc.TFLAG4_ONE_ROW_TOOLBAR);
            TerRecreateToolbar(false);
            ShowStatusBar = false;
            Action += new EventAction(AdvancedTxTextControl_Action);
            PostPaint += new EventPostPaint(AdvancedTxTextControl_PostPaint);
            Paint += new PaintEventHandler(AdvancedTxTextControl_Paint);
        }

        void AdvancedTxTextControl_PostPaint(object Sender, Graphics gr)
        {
            if (ControlPaint != null)
                ControlPaint(Sender, new EventArgs());
        }

        void AdvancedTxTextControl_Action(object Sender, int ActionType, int ActionId)
        {
            EventArgs e = new EventArgs();
            if (ActionType == tc.ACTION_HSCROLL)
            {
                if (HScrolled != null)
                {
                    HScrolled(Sender, e);
                }
            }
            else if (ActionType == tc.ACTION_VSCROLL)
            {
                if (VScrolled != null)
                {
                    VScrolled(Sender, e);
                }
            }
            else if (ActionType == tc.ACTION_STYLE)
            {
                if (FormatChanged != null)
                {
                    Console.WriteLine("Format Change : " + ActionType);
                    FormatChanged(Sender, e);
                }
            }
            else if (ActionType == tc.ACTION_COMMAND)
            {
                switch (ActionId)
                {
                    case tc.ID_UP:
                        if (VScrolled != null)
                        {
                            VScrolled(Sender, e);
                        }
                        break;
                    case tc.ID_DOWN:
                        if (VScrolled != null)
                        {
                            VScrolled(Sender, e);
                        }
                        break;
                    case tc.ID_DEL:
                        OnTextChanged(e);
                        break;
                    case tc.ID_BACK_SPACE:
                        OnTextChanged(e);
                        break;
                    case tc.ID_REPLACE:
                        OnTextChanged(e);
                        break;
                    case tc.ID_RETURN:
                        Console.WriteLine("ID_RETURN");
                        OnTextChanged(e);
                        break;
                }
            }
            if (ActionType == tc.ACTION_CHAR)
            {
                if (ActionId == 32)
                    OnTextChanged(e);
            }

            if (
                ActionType != 5 &&
                ActionType != 7 &&
                ActionType != 9 &&
                ActionType != 14 &&
                ActionType != 6 &&
                ActionType != 8 &&
                ActionType != 10
                )
            {
                
                OnTextChanged(EventArgs.Empty);
            }
        }

        void AdvancedTxTextControl_Paint(object sender, PaintEventArgs e)
        {
            if (ControlPaint != null)
                ControlPaint(sender, new EventArgs());
        }

        
        void _tsmiUndo_Click(object sender, EventArgs e)
        {
            TerCommand(tc.ID_UNDO);
        }

        void _tsmiCut_Click(object sender, EventArgs e)
        {
            TerCommand(tc.ID_CUT);
        }

        void _tsmiCopy_Click(object sender, EventArgs e)
        {
            TerCommand(tc.ID_COPY);
        }

        void _cmsPopupMenu_Opening(object sender, System.ComponentModel.CancelEventArgs e)
        {
            _tsmiDelete.Enabled = true;
            _tsmiCut.Enabled = true;
            _tsmiPaste.Enabled = true;
            _tsmiUndo.Enabled = true;

            if (ReadOnlyMode)
            {
                _tsmiDelete.Enabled = false;
                _tsmiCut.Enabled = false;
                _tsmiPaste.Enabled = false;
                _tsmiUndo.Enabled = false;
            }
        }

        void _tsmiSelectAll_Click(object sender, EventArgs e)
        {
            TerCommand(tc.ID_SELECT_ALL);
        }

        void _tsmiDelete_Click(object sender, EventArgs e)
        {
            TerCommand(tc.ID_CUT);
            Clipboard.Clear();
        }

        void _tsmiPaste_Click(object sender, EventArgs e)
        {
            TerCommand(tc.ID_PASTE);
        }
        

        public override string Text
        {
            get
            {

                this.TerSetOutputFormat(SubSystems.TE.tc.SAVE_TEXT);
                string text = this.Data.Replace("\r", "");
                this.TerSetOutputFormat(SubSystems.TE.tc.SAVE_DEFAULT);

                //this.TerCommand(tc.ID_SELECT_ALL);
                //string text = this.TerGetTextSel();
                //this.DeselectTerText(true);
                text = (text == null) ? string.Empty : text;
                //System.Diagnostics.Debug.WriteLine(text.Length);
                return text;
            }
            set
            {
                base.Text = value;
            }
        }

        
        private bool bHideSelection;

        public bool HideSelection
        {
            get { return bHideSelection; } //isn't used in TE. It's either painted when an action is performed or not.
            set { bHideSelection = value; this.DeselectTerText(true); }
        }

        public bool ReadOnly
        {
            get { return base.ReadOnlyMode; }
        }

        public void ScrollToCaret()
        {
            //System.Diagnostics.Debug.WriteLine(" scroll to Caret = " + TerGetTextSel());
            this.TerSearchReplace2(TerGetTextSel(), "", tc.SRCH_SEARCH + tc.SRCH_SCROLL, SelectionStart, 0);
            //this.TerEngageCaret(false);
        }

        public string SelectedText
        {
            get
            {
                //System.Diagnostics.Debug.WriteLine(this.TerGetTextSel());
                return this.TerGetTextSel();
            }
            set
            {
                this.TerDeleteBlock(false);
                this.InsertTerText(value, true);
            }
        }

        public int SelectionLength
        {
            get
            {
                //System.Diagnostics.Debug.WriteLine("get Selected Text = " + this.TerGetTextSel());
                return this.TerGetTextSel() != null ? this.TerGetTextSel().Length : 0;
            }
            set
            {
                //diag debug to figure out the call order of the interface.
                //System.Diagnostics.Debug.WriteLine("set SelectionLength = " + value.ToString());
                int line, col, endline, endcol;
                int absstart = this.SelectionStart;
                int absend = this.SelectionStart + value;
                this.TerAbsToRowCol(absend, out endline, out endcol);
                this.TerAbsToRowCol(absstart, out line, out col);
                this.SelectTerText(line, col, endline, endcol, true);
            }
        }

        public int SelectionStart
        {
            get
            {
                int line, col;
                line = this.TerGetParam(tc.TP_SELECTION_START_LINE);
                col = this.TerGetParam(tc.TP_SELECTION_START_COL);

                int ix = this.TerRowColToAbs(line, col);

                //diag debug to figure out the call order of the interface.
                //System.Diagnostics.Debug.WriteLine("get SelectionStart = " + ix.ToString()); 
                return ix;
            }
            set
            {
                //diag debug to figure out the call order of the interface.
                //System.Diagnostics.Debug.WriteLine("set SelectionStart = " + value.ToString());

                int line, col, endline, endcol;
                int absstart = value;
                int absend = value;
                this.TerAbsToRowCol(absend, out endline, out endcol);
                this.TerAbsToRowCol(absstart, out line, out col);
                this.SelectTerText(line, col, endline, endcol, true);
            }
        }



        

        public event EventHandler VScrolled;
        public event EventHandler VScrollEnd;
        public event EventHandler HScrolled;
        public event EventHandler ControlPaint;
        public event EventHandler FormatChanged;
        public event EventHandler ScrollCaret;


        public int GetLineFromCharIndex(int intCharIndex)
        {
            int line, col;
            this.TerAbsToRowCol(intCharIndex, out line, out col);
            //System.Diagnostics.Debug.WriteLine("GetLineFromCharIndex: " + line);
            return line;
        }
        public int GetCharIndexFromPos(System.Drawing.Point pontXY)
        {
            int line;
            int col = -1; // set to 0 to retrieve the position in line/column format.
            this.TerPixToTextPos(tc.REL_WINDOW, pontXY.X, pontXY.Y, out line, ref col);

            //System.Diagnostics.Debug.WriteLine("GetCharIndexFromPos: " + this.TerRowColToAbs(line, col));

            return this.TerRowColToAbs(line, col);
        }
        public Point GetPosFromCharIndex(int intCharIndex)
        {
            int x, y;
            this.TerTextPosToPix(tc.REL_WINDOW, intCharIndex, -1, out x, out y);

            //System.Diagnostics.Debug.WriteLine("GetPosFromCharIndex Char Index: " + intCharIndex);
            //System.Diagnostics.Debug.WriteLine("GetPosFromCharIndex: " + x.ToString() + " " + y.ToString());
            return new Point(x, y);
        }
        public int GetFirstVisibleCharIndex()
        {

            return 0;
        }

        public Keyoti.RapidSpell.TextBoxUtilityAdapter GetTBU()
        {
            if (tbu == null || tbu.IsFinished)
                tbu = new CustomTextBoxUtilityAdapter(this);
            return tbu;
        }

        public CustomTextBoxUtilityAdapter _tbu
        {
            set
            {
                tbu = value;
            }
            get
            {
                return tbu;
            }
        }
        public ContextMenuStrip ContextMenuStripDefault
        {
            get
            {
                return null;
            }
        }
        public ContextMenu ContextMenuDefault
        {
            get
            {
                return null;
            }
        }
        public ContextMenu DefaultContextMenu
        {
            get
            {
                return null;
            }
        }

        public int TextLength
        {
            get
            {
                //System.Diagnostics.Debug.WriteLine("Text Length: " + Text.Length);
                return Text.Length;
            }
        }
        public int GetBaselineOffsetAtCharIndex(int intCharIndex)
        {
            return TerScrLineHeight(GetLineFromCharIndex(intCharIndex));
        }
        
    }
    public class CustomTextBoxUtilityAdapter : TextBoxUtilityAdapter
    {
        public CustomTextBoxUtilityAdapter(AYTTern advText)
            :
           base(advText) { }
    }
}
